package cn.iocoder.yudao.module.system.controller.admin.biz;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassessdepression.ElderlyAssessDepressionPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassessdepression.ElderlyAssessDepressionRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassessdepression.ElderlyAssessDepressionSaveReqVO;
import cn.iocoder.yudao.module.system.service.biz.ElderlyAssessDepressionService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 抑郁自评量表")
@RestController
@RequestMapping("/elderly-assess-depression")
@Validated
public class ElderlyAssessDepressionController {

    @Resource
    private ElderlyAssessDepressionService elderlyAssessDepressionService;

    @PostMapping("/create")
    @Operation(summary = "创建抑郁自评量表")
    public CommonResult<Long> create(@Valid @RequestBody ElderlyAssessDepressionSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(elderlyAssessDepressionService.create(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "更新抑郁自评量表")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody ElderlyAssessDepressionSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        elderlyAssessDepressionService.update(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除抑郁自评量表")
    @Parameter(name = "id", description = "编号", required = true)
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        elderlyAssessDepressionService.delete(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得抑郁自评量表详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<ElderlyAssessDepressionRespVO> get(@RequestParam("id") Long id) {
        return success(elderlyAssessDepressionService.get(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得抑郁自评量表分页")
    @TenantIgnore
    public CommonResult<PageResult<ElderlyAssessDepressionRespVO>> page(@Valid ElderlyAssessDepressionPageReqVO pageReqVO) {
        if (pageReqVO.getTenantIds() == null) {
            pageReqVO.setTenantIds(new Long[]{TenantContextHolder.getTenantId()});
        }
        return success(elderlyAssessDepressionService.getPage(pageReqVO));
    }
}
